(function () {
  var remoteUrl = 'http://app.jlzgh.cn/mobiles/app/1.5.0/www/chcp.json'; //正式
  // var remoteUrl = 'http://jlappcs.longser.com/mobiles/app/www/chcp.json'; //测试54
  var rollbackKey = 'jilinapp_jl.rollback';
  var rollback = localStorage.getItem(rollbackKey) || false; //回滚
  var BundleId = "com.longser.jilin";
  var Splashscreen; //启动页
  var Dialogs; //提示窗
  var AppExit; //应用退出

  var Network; //联网情况
  var BetaPath; //外部文件地址
  var Platform; //平台

  var version_android = '1.8.0';//版本号 发布新版本时请保持当前版本号与服务器上check-android-version.jsp中版本号一致。并修改所有旧版本中的check-android-version.jsp以提示用户存在新版本
  var version_ios = '1.8.0';//版本号 发布新版本时请保持当前版本号与服务器上check-android-version.jsp中版本号一致。并修改所有旧版本中的check-android-version.jsp以提示用户存在新版本
  var versionUrl = 'https://app.jlzgh.cn/mobiles/api/system/check-android-version.jsp'; //大版本控制文件地址 //正式
  // var versionUrl = 'http://jlappcs.longser.com/mobiles/api/system/check-android-version.jsp'; //测试54
  //var BundleId;//应用ID 与config.xml中对应 iOS系统中专用

  /**
   * 错误处理 详情见https://github.com/nordnet/cordova-hot-code-push/wiki/Error-codes
   *   2: NOTHING_TO_UPDATE
   *   1: NOTHING_TO_INSTALL
   *  -1: FAILED_TO_DOWNLOAD_APPLICATION_CONFIG
   *  -2: APPLICATION_BUILD_VERSION_TOO_LOW
   *  -3: FAILED_TO_DOWNLOAD_CONTENT_MANIFEST
   *  -4: FAILED_TO_DOWNLOAD_UPDATE_FILES
   *  -5: FAILED_TO_MOVE_LOADED_FILES_TO_INSTALLATION_FOLDER
   *  -6: UPDATE_IS_INVALID
   *  -7: FAILED_TO_COPY_FILES_FROM_PREVIOUS_RELEASE
   *  -8: FAILED_TO_COPY_NEW_CONTENT_FILES
   *  -9: LOCAL_VERSION_OF_APPLICATION_CONFIG_NOT_FOUND
   * -10: LOCAL_VERSION_OF_MANIFEST_NOT_FOUND
   * -11: LOADED_VERSION_OF_APPLICATION_CONFIG_NOT_FOUND
   * -12: LOADED_VERSION_OF_MANIFEST_NOT_FOUND
   * -13: FAILED_TO_INSTALL_ASSETS_ON_EXTERNAL_STORAGE
   * -14: CANT_INSTALL_WHILE_DOWNLOAD_IN_PROGRESS
   * -15: CANT_DOWNLOAD_UPDATE_WHILE_INSTALLATION_IN_PROGRESS
   * -16: INSTALLATION_ALREADY_IN_PROGRESS
   * -17: DOWNLOAD_ALREADY_IN_PROGRESS
   * -18: ASSETS_FOLDER_IS_NOT_YET_INSTALLED
   * -19: NEW_APPLICATION_CONFIG_IS_INVALID
   * 不需要回退，需退出应用：-9, -11, -12
   * 服务器繁忙，需推出应用：-1, -3, -4, 
   * 不需处理：1,2,-2,-13,-18,-14, -15, -16, -17,
   * 需要回退并退出应用：-5,-6,-7,-8,-10,-19
   */

  var ServerErrCode = [-1, -3, -4];
  var ExitErrCode = [-9, -11, -12];
  var RollbackAndExitErrCode = [-5, -6, -7, -8, -10, -19];

  /**设备就绪**/
  document.addEventListener('deviceready', function (data) {
    Splashscreen = window.navigator.splashscreen;
    Dialogs = window.navigator.notification;
    AppExit = window.plugins.app;
    Platform = window.device.platform;
    Network = window.navigator.connection;

    if (Platform === "iOS") {
      BetaPath = window.cordova.file.applicationStorageDirectory + 'Library/Application Support/' + BundleId + '/cordova-hot-code-push-plugin/';
    } else {
      BetaPath = window.cordova.file.dataDirectory + 'cordova-hot-code-push-plugin/'; //file:///data/user/0/appid/files/
    }

    // console.log('BetaPath', BetaPath);
    // checkDir(BetaPath);//遍历文件夹

    /**网络检查 */
    if (Network.type == 'none') {
      Dialogs.alert('设备未联网，请联网后重试', function () {
        exitApp();
      }, '温馨提示', '确定');
    }

    //网络请求检查大版本是否需要更新
    
    httpGet(versionUrl, function (data) {
      if (data.errcode == undefined) {//成功获取到version版本号
        if(Platform == 'iOS'){
          if (version_ios != data.version_ios) {
            // Dialogs.alert('应用有新版本，请更新下载。').then(()=>{
            //   UpdateDownload();
            // })
            Dialogs.alert('应用有新版本，请更新下载。', function () {
              UpdateDownload();
            }, '温馨提示', '确定');
          }
        }else{
          if (version_android != data.version_android) {
            Dialogs.alert('应用有新版本，请更新下载。', function () {
              UpdateDownload();
            }, '温馨提示', '确定');
          }
        }
      }
      //checkUpdate();
    }, 5000);

    
  }, false);

  /**第一次安装应用复制至外部存储空间失败 errcode:-13*/
  document.addEventListener('chcp_assetsInstallationError', function (data) {
    console.log('chcp_assetsInstallationError', data);
    Dialogs.alert('存储空间不足，请清理手机空间后重新下载安装', function () {
      exitApp();
    }, '温馨提示', '确定');
  }, false);

  /**获取配置文件失败 */
  document.addEventListener('chcp_updateLoadFailed', function (data) {
    Splashscreen.hide();
  }, false);

  /**新文件下载完成，未安装 */
  document.addEventListener('chcp_updateIsReadyToInstall', function (data) {
    console.log('chcp_updateIsReadyToInstall', data);
    Splashscreen.hide();
  }, false);


  /**无新文件下载且无新文件安装 */
  document.addEventListener('chcp_nothingToUpdate', function (data) {
    console.log('chcp_nothingToUpdate', data);
    Splashscreen.hide();
  }, false);

  /**
   * http请求
   * @param {*} url 地址
   * @param {*} callback 回调
   * @param {*} time 超时时间
   */
  function httpGet(url, callback, time) {
    var request = new XMLHttpRequest();
    var timeout = false;
    var time = time || 0;

    var timer = setTimeout(function () {
      timeout = true;
      request.abort();
    }, time);

    request.open("GET", url);
    request.onreadystatechange = function () {
      if (request.readyState !== 4) {
        return;
      }

      if (timeout) {
        callback({
          errcode: -1,
          errmsg: 'timeout'
        });//报错
        return;
      }

      if (request.status === 200) {
        clearTimeout(timer);
        callback(JSON.parse(request.responseText));
      }
    }
    request.send();
  }

  //下载新版本
  function UpdateDownload(){
    if(Platform == 'iOS'){
      window.location.href="https://apps.apple.com/cn/app/%E5%90%89%E5%B7%A5e%E7%AB%99/id1345311740";
      setTimeout(function () {
        exitApp();
      }, 2000);
      return;
    }else{
      // window.location.href="http://cdn.jlzgh.cn/app/app-debug.apk";
      window.location.href="http://cdn.jlzgh.cn/app/download.html";
      setTimeout(function () {
        exitApp();
      }, 2000);
      return;
    }
  }

  function checkUpdate(){
    if (rollback === 'true') {
      removeDir(BetaPath);
    } else {
      /**检查是否有需要安装的更新 */
      chcp.isUpdateAvailableForInstallation(function (error, data) {
        localStorage.setItem(rollbackKey, true); //设置回滚标记

        if (error) { //没有需要安装的更新
          console.log('Nothing to install. Executing fetch.', error);
          var options = {
            'config-file': remoteUrl,
            'request-headers': {
              'Pragma': 'no-cache',
              'Expires': '0',
              'Cache-Control': 'no-cache'
            }
          };
          chcp.fetchUpdate(fetchUpdateCallback, options); //检查更新
          return;
        }

        chcp.installUpdate(installationCallback); //安装更新
      });
    }
  }

  /**检查更新回调**/
  function fetchUpdateCallback(error, data) {
    console.log('fetchUpdateCallback result', error);
    // alert('fetchUpdateCallback'+JSON.stringify(error));
    if (error) { //下载失败或无下载
      var errcode = error.code;
      if (ServerErrCode.indexOf(errcode) > -1) {
        Dialogs.alert('服务器繁忙，请稍后重试', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (ExitErrCode.indexOf(errcode) > -1) {
        localStorage.setItem(rollbackKey, false);
        Dialogs.alert('启动失败，请重启应用', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (RollbackAndExitErrCode.indexOf(errcode) > -1) {
        removeDir(BetaPath);
      } else {
        localStorage.setItem(rollbackKey, false);
      }
    } else { //下载成功
      localStorage.setItem(rollbackKey, false);
      Dialogs.alert('应用有更新，重启安装更新', function () {
        exitApp();
      }, '温馨提示', '确定');
    }
  }

  /**安装更新回调**/
  function installationCallback(error, data) {
    if (error) { //安装失败
      console.log('installationCallback error', error);
      var errcode = error.code;
      if (ServerErrCode.indexOf(errcode) > -1) {
        Dialogs.alert('服务器繁忙，请稍后重试', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (ExitErrCode.indexOf(errcode) > -1) {
        localStorage.setItem(rollbackKey, false);
        Dialogs.alert('启动失败，请重启应用', function () {
          exitApp();
        }, '温馨提示', '确定');
      } else if (errcode in RollbackAndExitErrCode) {
        removeDir(BetaPath);
      }
    } else { //下载成功
      localStorage.setItem(rollbackKey, false);
      console.log('Update installed!');
    }
  }

  /**遍历文件夹**/
  function checkDir(dirName) {
    window.resolveLocalFileSystemURL(dirName, function (dirEntry) {
      //显示根目录下的内容  
      var dirReader = dirEntry.createReader();
      var entries = [];
      var readEntries = function () {
        //返回FileEntry数组  
        dirReader.readEntries(function (results) {
          if (!results.length) {
            showEntries(entries.sort());
          } else {
            entries = entries.concat(toArray(results));
            readEntries();
          }
        }, errorHandler);
      }
      readEntries();
    });

    function errorHandler(err) {
      console.info(err);
    }

    function toArray(list) {
      return Array.prototype.slice.call(list || [], 0);
    }
    //显示读取结果  
    function showEntries(entries) {
      console.info(entries);
    }
  }

  /**删除文件夹**/
  function removeDir(dirName) {
    window.resolveLocalFileSystemURL(dirName, function (fileSystem) {
      fileSystem.removeRecursively(function (data) {
        console.log('removeDir success', data);
        Dialogs.alert('更新失败，请重启应用', function (data) {
          localStorage.setItem(rollbackKey, false);
          exitApp();
        }, '温馨提示', '确定');
      }, function (error) {
        console.log('removeDir error', error);
        Dialogs.alert('更新失败，请重启应用', function () {
          exitApp();
        }, '温馨提示', '确定');
      });
    })
  }

  //读取文件
  function readFile(fileEntry) {
    fileEntry.file(function (file) {
      var reader = new FileReader();
      reader.onloadend = function () {
        console.log(this.result);
      };
      reader.readAsText(file);
    }, function (err) {
      console.log("文件读取失败!", err);
    });
  }

  /**退出app**/
  function exitApp() {
    AppExit.exit({
      "platform": Platform
    });
  }

})();
